function pose_new = add_odometry(odom, pose)
% Function for adding a odometry measurement to a pose.
% Used to get a pose estimation only based on the odometry
% measurements.

  r1 = atan2(odom(2), odom(1));
  t = sqrt(odom(1)^2 + odom(2)^2);
  r2 = odom(3) - r1;

  pose_new = pose + [ ...
      t .* cos(pose(3) + r1), ...
      t .* sin(pose(3) + r1), ...
      r1 + r2 ...
      ];

end

