function weight = measurement_model(z, x, l)
    % Computes the observation likelihood of all particles.
    %
    % The employed sensor model is range only.
    %
    % z: set of landmark observations. Each observation contains the index of the 
    %    landmark observed in z(i,1), the measured range in z(i,2) and the
    %    measured bearing in z(i,3).
    % x: set of current particles
    % l: map of the environment composed of all landmarks (x,y)

    % noise parameters
    sigma = [0.4, 0.2]; % range, bearing
    weight = ones(size(x, 1), 1);

    if size(z, 2) == 0
        return
    end
    
    for i = 1:size(z, 1)

        landmark_position = l(z(i,1),:);
        measurement_range = z(i,2);
        measurement_bearing = z(i,3);

        %% TODO: compute weights for the range

        %% TODO: compute weights for the bearing
        
    end

    if size(z, 1) > 0
      weight = weight ./ size(z, 1);
    end
end
