function [X_new, mean] = particle_filter(z, u, X, landmarks);
  % Computes the new set of particles X_new and the mean,
  % given the measurements z and u, the prior belief X and the
  % landmarks. 

  if isempty(X)
    % Initialize particles
    disp('Init particles');
    X = initialize_particles(200);
  end

  X_new = sample_motion_model(u, X);

  weights = measurement_model(z, X_new, landmarks);
  normalizer = sum(weights);
  weights = weights ./ normalizer;

  mean = mean_position(X_new, weights);   

  X_new = resample(X_new, weights);

end
