clear all;
addpath('particlefilter');

% Loads landmarks
landmarks = load('data/landmarks.dat');
disp('landmark 6 is:');
disp(landmarks(6,:));

% Create some particle poses
particles = [-1 0 0.5; 1 1 0.5; 0 4 0.15; 5.5 -2 1.7];

% Create a measurement (id, range, bearing)
z = [6, 7, 0.2]

% Check measurement_model
likelihoods = measurement_model(z, particles, landmarks);
normalized_likelihoods = likelihoods' ./ sum(likelihoods)

disp('expecting normalized_likelihoods (range only):');
disp('   0.2143    0.1018    0.3200    0.3640');
disp('expecting normalized_likelihoods (range and bearing):');
disp('   0.4327    0.2249    0.2103    0.1321');



